/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.c
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2024 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "dma.h"
#include "i2c.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

#include <stdio.h>
#include <string.h>
#include "printf.h"  // https://embeddedartistry.com/blog/2019/11/06/an-embedded-friendly-printf-implementation/
#include "mcp9808.h" // https://embeddedespresso.com/temperature-measurement-never-so-easy-with-stm32-and-mcp9808/

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

#define UART_SEND_PERIOD 500
#define UART_BUS_POINTER (&huart2)
//#define USE_SPRINTF_INSIDE_INTERRUPT
//#define DONT_USE_DMA_INSIDE_INTERRUPT

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

uint8_t msgstr[64]; /* String where to store the serial port output */

float tempVal;
float tempLower;
float tempUpper;
float tempRef = 40.0;
float tempHysteresisWidth = 5.0;

uint32_t UartSoftTimer;

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */
void control_loop(void);

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

void control_loop(void)
{
	HAL_GPIO_WritePin(LOGIC_ANALYZER_CONTROL_GPIO_Port,
	LOGIC_ANALYZER_CONTROL_Pin, GPIO_PIN_SET);

	tempVal = Mcp9808GetTemperature();

#ifdef USE_SPRINTF_INSIDE_INTERRUPT
	HAL_GPIO_WritePin(LOGIC_ANALYZER_CONTROL_GPIO_Port,
	LOGIC_ANALYZER_CONTROL_Pin, GPIO_PIN_RESET);
	/* Prepare a formatted string, with the temperature value */
	sprintf((char*) msgstr, "Temperature is %.3f °C\r\n", tempVal);
	HAL_GPIO_WritePin(LOGIC_ANALYZER_CONTROL_GPIO_Port,
	LOGIC_ANALYZER_CONTROL_Pin, GPIO_PIN_SET);

	/* Transmit the message over UART */
#ifdef	DONT_USE_DMA_INSIDE_INTERRUPT
	HAL_UART_Transmit(&huart2, msgstr, strlen((char*) msgstr), 200u);
#else
	HAL_UART_Transmit_DMA(&huart2, msgstr, strlen((char*) msgstr));
#endif // DONT_USE_DMA_INSIDE_INTERRUPT
#endif // USE_SPRINTF_INSIDE_INTERRUPT
	HAL_GPIO_WritePin(HYSTERESIS_CONTROL_GPIO_Port, HYSTERESIS_CONTROL_Pin,
			hysteresis_controller(tempRef - tempVal, tempHysteresisWidth));
	tempLower = tempRef - tempHysteresisWidth / 2; // for STM32CubeMonitor
	tempUpper = tempRef + tempHysteresisWidth / 2; // for STM32CubeMonitor
	HAL_GPIO_WritePin(LOGIC_ANALYZER_CONTROL_GPIO_Port,
	LOGIC_ANALYZER_CONTROL_Pin, GPIO_PIN_RESET);
}

/* USER CODE END 0 */

/**
 * @brief  The application entry point.
 * @retval int
 */
int main(void)
{

	/* USER CODE BEGIN 1 */

	/* USER CODE END 1 */

	/* MCU Configuration--------------------------------------------------------*/

	/* Reset of all peripherals, Initializes the Flash interface and the Systick. */
	HAL_Init();

	/* USER CODE BEGIN Init */

	/* USER CODE END Init */

	/* Configure the system clock */
	SystemClock_Config();

	/* USER CODE BEGIN SysInit */

	/* USER CODE END SysInit */

	/* Initialize all configured peripherals */
	MX_GPIO_Init();
	MX_DMA_Init();
	MX_USART2_UART_Init();
	MX_I2C3_Init();
	MX_TIM15_Init();
	/* USER CODE BEGIN 2 */

	Mcp9808SetResolution(2);

	HAL_TIM_Base_Start_IT(&htim15); // control loop interrupt

	UartSoftTimer = HAL_GetTick();
	/* USER CODE END 2 */

	/* Infinite loop */
	/* USER CODE BEGIN WHILE */
	while (1)
	{
#ifndef USE_SPRINTF_INSIDE_INTERRUPT
		if ( HAL_GetTick() - UartSoftTimer > UART_SEND_PERIOD)
		{
			UartSoftTimer = HAL_GetTick();
			sprintf((char*) msgstr, "Temperature is %.3f °C\r\n", tempVal);
			HAL_UART_Transmit_DMA(UART_BUS_POINTER, msgstr, strlen((char*) msgstr));
		}
#endif
		/* USER CODE END WHILE */

		/* USER CODE BEGIN 3 */
	}
	/* USER CODE END 3 */
}

/**
 * @brief System Clock Configuration
 * @retval None
 */
void SystemClock_Config(void)
{
	RCC_OscInitTypeDef RCC_OscInitStruct =
	{ 0 };
	RCC_ClkInitTypeDef RCC_ClkInitStruct =
	{ 0 };

	/** Configure the main internal regulator output voltage
	 */
	HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1);

	/** Initializes the RCC Oscillators according to the specified parameters
	 * in the RCC_OscInitTypeDef structure.
	 */
	RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI;
	RCC_OscInitStruct.HSIState = RCC_HSI_ON;
	RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
	RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
	RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
	RCC_OscInitStruct.PLL.PLLM = RCC_PLLM_DIV2;
	RCC_OscInitStruct.PLL.PLLN = 25;
	RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
	RCC_OscInitStruct.PLL.PLLQ = RCC_PLLQ_DIV2;
	RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV2;
	if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
	{
		Error_Handler();
	}

	/** Initializes the CPU, AHB and APB buses clocks
	 */
	RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK | RCC_CLOCKTYPE_SYSCLK
			| RCC_CLOCKTYPE_PCLK1 | RCC_CLOCKTYPE_PCLK2;
	RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
	RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
	RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
	RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

	if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_3) != HAL_OK)
	{
		Error_Handler();
	}
}

/* USER CODE BEGIN 4 */

void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{
	if (htim->Instance == TIM15)
	{
		HAL_GPIO_TogglePin(LOGIC_ANALYZER_TIM15_GPIO_Port,
		LOGIC_ANALYZER_TIM15_Pin);
		control_loop();
	}
}
/* USER CODE END 4 */

/**
 * @brief  This function is executed in case of error occurrence.
 * @retval None
 */
void Error_Handler(void)
{
	/* USER CODE BEGIN Error_Handler_Debug */
	/* User can add his own implementation to report the HAL error return state */
	__disable_irq();
	while (1)
	{
	}
	/* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
